package ch.unige.solidify.repository;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.data.repository.NoRepositoryBean;

@NoRepositoryBean
public interface SolidifyCompositeRepositoryNoSql<T> extends SolidifyRepositoryNoSql<T> {
  default <V> Page<V> findByParentId(String parentId, Class<?> parentClass, Class<V> childClass,
          Pageable pageable) {
    throw new UnsupportedOperationException("Missing implementation 'findByParentId' method ("
            + parentClass.getSimpleName() + " -> " + childClass.getSimpleName() + ")");
  }

  default <V> V findByParentIdAndChildId(String parentId, Class<?> parentClass, Class<V> childClass,
          String id) {
    throw new UnsupportedOperationException("Missing implementation 'findByParentIdAndChildId' method ("
            + parentClass.getSimpleName() + " -> " + childClass.getSimpleName() + ")");
  }
}
