package ch.unige.solidify.oracle.test.web;

import org.springframework.boot.SpringApplication;
import org.springframework.boot.autoconfigure.SpringBootApplication;
import org.springframework.boot.autoconfigure.domain.EntityScan;
import org.springframework.boot.builder.SpringApplicationBuilder;
import org.springframework.boot.web.servlet.support.SpringBootServletInitializer;
import org.springframework.context.annotation.ComponentScan;
import org.springframework.context.annotation.FilterType;
import org.springframework.context.annotation.PropertySource;
import org.springframework.data.jpa.repository.config.EnableJpaRepositories;

@SpringBootApplication(exclude = {
        org.springframework.boot.autoconfigure.security.servlet.SecurityAutoConfiguration.class,
        org.springframework.boot.actuate.autoconfigure.security.servlet.ManagementWebSecurityAutoConfiguration.class })
@ComponentScan(basePackages = { "ch.unige.solidify.oracle.test", "ch.unige.solidify" },
               excludeFilters = @ComponentScan.Filter(type = FilterType.REGEX, pattern = "ch\\.unige\\.solidify\\.test\\..*"))
@PropertySource("classpath:oracle_config.properties")
@EnableJpaRepositories(basePackages = { "ch.unige.solidify.oracle.test.dao" })
@EntityScan(basePackages = "ch.unige.solidify.oracle.test")
public class TestConfigApplication extends SpringBootServletInitializer {
  public static void main(String[] args) {
    SpringApplication.run(TestConfigApplication.class, args);
  }

  @Override
  protected SpringApplicationBuilder configure(SpringApplicationBuilder application) {
    return application.sources(TestConfigApplication.class);
  }

}
