package ch.unige.solidify.specification;

import java.util.ArrayList;
import java.util.List;
import javax.persistence.criteria.CriteriaBuilder;
import javax.persistence.criteria.CriteriaQuery;
import javax.persistence.criteria.Predicate;
import javax.persistence.criteria.Root;

import ch.unige.solidify.rest.JoinResource;

public abstract class Join2TiersSpecification<J extends JoinResource<J, ?>> extends JoinNTiersSpecification<J> {

  public Join2TiersSpecification(J joinCriteria, String pathToParent, String pathToChild) {
    super(joinCriteria, pathToParent, pathToChild);
  }

  @Override
  public Predicate toPredicate(Root<J> root, CriteriaQuery<?> query, CriteriaBuilder builder) {
    final List<Predicate> predicatesList = new ArrayList<>();

    // ensure only children of parent are found
    this.completeParentIdPredicate(root, query, builder, predicatesList);

    if (this.filterOnChildResId) {
      // ensure the child has specific id (used to get one specific child)
      this.completeChildIdPredicate(root, query, builder, predicatesList);
    } else {

      // allow to filter on join table properties
      this.completeJoinPredicatesList(root, query, builder, predicatesList);

      // allow to filter list of children on child properties
      this.completeChildPredicatesList(root, query, builder, predicatesList);
    }

    return builder.and(predicatesList.toArray(new Predicate[predicatesList.size()]));
  }
}
