package ch.unige.solidify.specification;

import java.util.ArrayList;
import java.util.List;

public class JoinedTableInValues {
  private String relationName;
  private String fieldName;
  private final List<Object> values = new ArrayList<>();

  public JoinedTableInValues(String relationName, String fieldName, List<Object> values) {
    this.relationName = relationName;
    this.fieldName = fieldName;
    this.values.addAll(values);
  }

  public String getRelationName() {
    return this.relationName;
  }

  public String getFieldName() {
    return this.fieldName;
  }

  public List<Object> getValues() {
    return this.values;
  }

  public void addValue(Object value) {
    this.values.add(value);
  }
}
