package ch.unige.solidify.test.util;

import org.junit.Assert;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.springframework.test.context.junit4.SpringRunner;

import ch.unige.solidify.rest.ResourceNormalized;
import ch.unige.solidify.util.ReflectionTool;

@RunWith(SpringRunner.class)
public class ReflectionToolTest {
  private static class ResourceTest extends ResourceNormalized<ResourceTest> {

    @Override
    public void init() {
    }

    @Override
    public String managedBy() {
      return null;
    }

    public void setMyField() {
      Assert.assertEquals("myField", ReflectionTool.getCurrentSetterVariableName());
    }
  }

  @Test
  public void getCurrentSetterVariableNameTest() {
    final ResourceTest resourceTest = new ResourceTest();
    resourceTest.setMyField();
  }

}
