package ch.unige.solidify;

//Embedded classes
public enum ChecksumAlgorithm {
  CRC32("CRC32"), MD5("MD5"), SHA1("SHA-1"), SHA256("SHA-256");

  /*
   * Override constructor and toString() to get supported values for algorithm names (see
   * https://stackoverflow.com/questions/12642742/exception-when-calling-messagedigest-
   * getinstancesha256#12642834)
   */
  private final String value;

  private ChecksumAlgorithm(String realName) {
    this.value = realName;
  }

  @Override
  public String toString() {
    return this.value;
  }
}
